import { Observable, PartialObserver as Listener, Subscription } from 'rxjs'
import { PushEvent } from './baseTypes'
export { Listener, Subscription }
export interface UseEvent {
    (eventName: string): [Observable<void>, () => any]
    <Type = any>(eventName: string, seedValue?: Type): [
        Observable<Type>,
        (val: Type) => any
    ]
}
export interface FromEvent {
    (eventName: string): Observable<void>
    <Type>(
        eventName: string,
        valueTransformer?: (val: any) => Type
    ): Observable<Type>
}
export interface ObservableComponentBase {
    mount: Observable<any>
    unmount: Observable<any>
    fromEvent: FromEvent
    pushEvent: PushEvent
    useEvent: UseEvent
}
export interface Observe {
    observe: <Type>(
        propName?: string,
        valueTransformer?: (val: any) => Type
    ) => Observable<Type>
}
export declare type ObservableComponent = Observe & ObservableComponentBase
export declare type Aperture<Props, Effect, Context = any> = (
    component: ObservableComponent,
    initialProps: Props,
    initialContext?: Context
) => Observable<Effect>
export declare const subscribeToSink: <Type>(
    sink: Observable<Type>,
    next: (val: Type) => void,
    error?: (error: any) => void
) => Subscription
export declare const createObservable: (
    subscribe: any
) => {
    [x: string]: any
    subscribe: any
}
export declare const getObserve: <Props>(
    getProp: any,
    data: any,
    decoratedProps: any
) => <Type>(propName?: any, valueTransformer?: any) => any
export declare const createComponent: <Props>(
    getProp: any,
    dataObservable: any,
    pushEvent: PushEvent,
    decoratedProps: boolean
) => ObservableComponent
